

-- Test by:
--   Send message 
--   Read message, send response, end conversation
--   Receive response, end conversation

--
-- Step 1: Start a dialog and send a message
--
--

:CONNECT localhost\SQLDEV01
GO

USE TestDB
GO

--
-- We're replacing a 
-- Traditional transaction update orders and inventory
-- see if this works
--
DECLARE @orderform XML

BEGIN TRANSACTION
	INSERT INTO orders VALUES(347, GETDATE()) 
	INSERT INTO order_form VALUES(SCOPE_IDENTITY(), @orderform);

	UPDATE	inventory 
	SET		units_in_stock = units_in_stock - 3
	WHERE	product_id = 1040;
COMMIT
go

SELECT * FROM inventory
go

-- END TRADITIONAL TRANSACTION

drop proc update_inventory
GO
-- Encapsulate the broker step into a stored procedure
CREATE PROCEDURE update_inventory(@product_id INT, @units_ordered INT)
AS
DECLARE @h UNIQUEIDENTIFIER;
-- hard code this for now
DECLARE @invreq XML;
SET @invreq = '
<InventoryReq xmlns="http://www.company.com/inventoryRequest">
  <order>1</order>
  <product>1040</product>
  <units>3</units>
  <status>Req</status>
</InventoryReq>';

BEGIN TRY
BEGIN TRANSACTION;
BEGIN DIALOG CONVERSATION @h
 FROM SERVICE InvInitiator
 TO SERVICE 'InvService'
 ON CONTRACT InvContract
 WITH ENCRYPTION = OFF;

-- request for product 1040
SEND ON CONVERSATION @h 
 MESSAGE TYPE InvRequestMsg (@invreq);
COMMIT;
END TRY
BEGIN CATCH
	PRINT ERROR_MESSAGE()
    ROLLBACK;
END CATCH
GO

--
-- Rewrite initiator for process into procedure
--

DECLARE @i INT
SET @i = 1
WHILE @i < 2
 BEGIN
   DECLARE @orderform XML
   BEGIN TRANSACTION
   INSERT INTO orders VALUES(347, GETDATE()) 
   INSERT INTO order_form VALUES(SCOPE_IDENTITY(), @orderform);
   EXECUTE update_inventory 1040, 3
   COMMIT
   SET @i = @i + 1
 END
go

-- select * from sys.transmission_queue
-- select * from TestInitiatorQueue
-- select * from sys.conversation_endpoints

--
-- Step 2: Check that inventory has been reduced
-- This happens at the target.
--

:CONNECT localhost\SQLDEV02
GO

USE TestDB
GO

-- select * from sys.transmission_queue
-- select * from TestTargetQueue
-- select * from sys.conversation_endpoints

SELECT * FROM dbo.Inventory
WHERE Product_ID = 1040
GO
