
-- SQL login
create login fred with 
 password = 'StrongPW1' must_change,
 default_database = pubs,
 default_language = british,
 check_expiration = on,
 check_policy = on
go

-- Windows login based on user
create login [ZMV10\Mary] from windows
go

-- Windows login based on group
create login [ZMV10\payroll] from windows
go

create credential asbob with identity = 'ZMV10\bobb',
 secret = 'mypassword'
go

use pubs
go

create user simon from login fred
-- sp_grantdbaccess will go away in future version
-- sp_grantdbaccess 'zmv10\Mary', 'Mary'
create user Mary from login [zmv10\Mary]
create user [zmv10\payroll] from login [zmv10\payroll]

create role payroll 
sp_addrolemember 'payroll', 'zmv10\payroll'

-- cleanup
sp_droprolemember 'payroll', 'zmv10\payroll'
drop role payroll
drop user simon
drop user Mary
drop schema [zmv10\payroll]
drop user [zmv10\payroll]
go

drop login [zmv10\payroll]
drop login [zmv10\Mary]
drop login fred
drop credential asbob
go